<?php

class ModelProductsToStoreByManufacturer extends Model
{
	public function updateProductToStore($manufacturer_id, $default_store_id = false)
	{
		$manufacturer_products	= $this->getProductsByManufacturer($manufacturer_id);
		$manufacturer_stores	= $this->getStoresByManufacturer($manufacturer_id);

		// cleanup old links
		$del_query = 'DELETE FROM ' . DB_PREFIX . 'product_to_store WHERE product_id IN (' . implode( ',', $manufacturer_products ). ');';
		$this->db->query($del_query);

		$upd_values = array();

		if ($default_store_id === false)
		{ // update
			foreach ($manufacturer_stores as $store_id)
			{
				// multi single store inserts
				//$upd_values = array();

				foreach ( $manufacturer_products as $product_id )
				{
					$upd_values[] = "(" . (int)$product_id . "," . (int)$store_id . ")";
				}

				// multi single store inserts
				// $upd_query = 'INSERT INTO ' . DB_PREFIX . 'product_to_store (product_id, store_id) VALUES ' . implode( ',', $upd_values ) . ";\n";
			}
		}
		else
		{ // reset to default
			foreach ( $manufacturer_products as $product_id )
			{
				$upd_values[] = "(" . (int)$product_id . "," . (int)$default_store_id . ")";
			}
		}

		// set out new links
		// one multi store insert
		$upd_query = 'INSERT INTO ' . DB_PREFIX . 'product_to_store (product_id, store_id) VALUES ' . implode( ',', $upd_values ) . ";";
		$this->db->query($upd_query);

		$this->cache->delete('product');
	}

	public function getProductsByManufacturer($manufacturer_id)
	{
      	$query = $this->db->query("SELECT product_id FROM " . DB_PREFIX . "product WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		foreach ($query->rows as $result)
		{
			$products_data[] = $result['product_id'];
		}

		return $products_data;
	}

	public function getStoresByManufacturer($manufacturer_id)
	{
		$manufacturer_store_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "manufacturer_to_store WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		foreach ($query->rows as $result)
		{
			$manufacturer_store_data[] = $result['store_id'];
		}

		return $manufacturer_store_data;
	}

}

?>